<template>
  <div id="project-add-new">
    <div class="modal-header p-2">Thêm Thẻ</div>
    <div class="modal-body">
      <LabelForm v-model="labelLocal" :isValid="validateForm" />
    </div>
    <div class="modal-footer">
      <vs-button @click="onSave">Lưu</vs-button>
      <vs-button @click="$emit('close')">Hủy bỏ</vs-button>
    </div>
  </div>
</template>

<script>
import LabelForm from "./LabelForm.vue";
import LabelService from "../../services/LabelService";

export default {
  name: "label-add-new",
  components: {
    LabelForm
  },
  props: {
    info: { type: Object, default: () => ({}) }
  },
  data() {
    return {
      labelLocal: this.info
    };
  },
  computed: {
    validateForm() {
      return !this.errors.any() && this.labelLocal.name != "";
    }
  },
  methods: {
    clearFields() {
      Object.assign(this.labelLocal, {
        name: "",
        isFavorite: false,
        color: "berry-red"
      });
    },
    async onSave() {
      this.$validator.validateAll().then(async result => {
        if (result) {
          try {
            const res = await LabelService.update(
              this.labelLocal._id,
              this.labelLocal
            );

            this.$success(res.message);

            // Fetch Tags
            this.$store.dispatch("todo/fetchTags");

            this.$emit("close");
          } catch (error) {
            this.$error(error.message);
          }

          // Clear field
          this.clearFields();
        }
      });
    }
  }
};
</script>
